#define PI 3.141592653589793

varying vec3 vColor;
varying mat3 vRot;
varying float bokehPower;

varying vec3 vN;

uniform float alpha;
uniform float elapsedTime;
uniform sampler2D ditheredSpriteTexture;
uniform sampler2D bayer;

uniform float aux;

uniform float ditherCurve;
uniform float ditherBias;

uniform float zoom;

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

float dither(float brightness) {
	float bay = texture2D(bayer, gl_FragCoord.xy/8.0).r;
    bay = pow(bay, 1.0 / 2.2); //Gamma correction
    // bay = pow(bay, 1.0 / (aux*5.0)); //Gamma correction
    return step(bay-1.0/8.0, brightness);
    // return bay;
}

void main() {
	vec2 uv = vec2(gl_PointCoord.x, 1.0 - gl_PointCoord.y);
	vec2 center = vec2(0.5, 0.5);
	uv -= center;
	uv = (vec3(uv, 1.0) * vRot).xy;
	uv += center;
	vec4 tex = texture2D(ditheredSpriteTexture, uv);

  tex *= zoom;

	if (dither(pow(tex.a, 2.2)) == 0.0) discard;

	// gl_FragColor = vec4(vColor, 1.0) * tex;

	// if (tex.a < 0.5) discard;

	gl_FragColor = vec4(vColor, tex.a);

	// gl_FragColor = tex;
	// gl_FragColor = vec4(1.0);

	// gl_FragColor = vec4(1.0, 1.0, 0.0, tex.a);
	// gl_FragColor = vec4(1.0, 1.0, 0.0, 1.0);
	// gl_FragColor = vec4(mix(vec3(1.0, 0.0, 0.0), vec3(1.0, 1.0, 0.0), tex.a), 1.0);

	// float v = pow(uv.x, 2.2);
	// v = mix(v, dither(v), step(0.5, uv.y));
	// gl_FragColor = vec4(v, v, v, 1.0);

}